//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%37F0D2BDE250.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%37F0D2BDE250.cm

//## begin module%37F0D2BDE250.cp preserve=no
//## end module%37F0D2BDE250.cp

//## Module: MulComponent%37F0D2BDE250; Package specification
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/MulComponent.h

#ifndef MULCOMPONENT_H
#define MULCOMPONENT_H 1

//## begin module%37F0D2BDE250.additionalIncludes preserve=no
//## end module%37F0D2BDE250.additionalIncludes

//## begin module%37F0D2BDE250.includes preserve=yes
//## end module%37F0D2BDE250.includes

// Component
#include <XSModel/Model/Component/Component.h>

class SumComponent;

//## begin module%37F0D2BDE250.declarations preserve=no
//## end module%37F0D2BDE250.declarations

//## begin module%37F0D2BDE250.additionalDeclarations preserve=yes
//## end module%37F0D2BDE250.additionalDeclarations


//## begin MulComponent%3628095A0096.preface preserve=yes
//## end MulComponent%3628095A0096.preface

//## Class: MulComponent%3628095A0096
//	Multiplicative Component. ComponentGroup must contain
//	one or more of MulComponent and ConComponent
//## Category: XSModel::Model::Component%3666B89A8340
//## Subsystem: XSModel::Model::Component%367691A33718
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A8D45CF01B4;CGroupBase { -> }
//## Uses: <unnamed>%3C62B9E8021B;ComponentBase { -> }
//## Uses: <unnamed>%3C62BC630340;SumComponent { -> F}

class MulComponent : public Component  //## Inherits: <unnamed>%3687BAB623D0
{
  //## begin MulComponent%3628095A0096.initialDeclarations preserve=yes
  //## end MulComponent%3628095A0096.initialDeclarations

  public:
    //## Constructors (generated)
      MulComponent(const MulComponent &right);

    //## Constructors (specified)
      //## Operation: MulComponent%37EF94C1DE70;    C++
      MulComponent (CGroupBase* p);

    //## Destructor (generated)
      virtual ~MulComponent();


    //## Other Operations (specified)
      //## Operation: operator*%37682B6B6A08;    C++
      virtual SumComponent& operator * (SumComponent& right) const;

      //## Operation: clone%38E3B5E39D08
      virtual MulComponent* clone (CGroupBase* p) const;

      //## Operation: calculate%3ADB04070040;            C++
      virtual void calculate (bool saveComponentFlux, bool frozen);

    // Additional Public Declarations
      //## begin MulComponent%3628095A0096.public preserve=yes
      //## end MulComponent%3628095A0096.public

  protected:
    // Additional Protected Declarations
      //## begin MulComponent%3628095A0096.protected preserve=yes
      //## end MulComponent%3628095A0096.protected

  private:

    //## Other Operations (specified)
      //## Operation: copy%3A953F240283
      virtual void copy (const Component& right);

    // Additional Private Declarations
      //## begin MulComponent%3628095A0096.private preserve=yes
      //## end MulComponent%3628095A0096.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin MulComponent%3628095A0096.implementation preserve=yes
      //## end MulComponent%3628095A0096.implementation

};

//## begin MulComponent%3628095A0096.postscript preserve=yes
//## end MulComponent%3628095A0096.postscript

// Class MulComponent 

//## begin module%37F0D2BDE250.epilog preserve=yes
//## end module%37F0D2BDE250.epilog


#endif
